<template>
  <q-page class="flex flex-center">
    <q-list>
      <q-item-label header>{{ $t('settings.categories.h1') }}</q-item-label>

      <div class="row q-ma-md gutter-x-xs">
        <div>
          <q-input v-model="ctgObject.name" :label="$t('settings.categories.name')" class="q-mr-md"
                   @keyup="keyupCtg" />
        </div>
        <div>
          <q-input v-model="ctgObject.ageTo" :label="$t('settings.categories.ageTo')"
                   class="q-mr-md" type="number"
                   @keyup="keyupCtg" />
        </div>
        <q-field class="q-mr-md" stack-label
                 :label="$t('settings.categories.sex')" :label-width="12">
          <q-btn-toggle v-model="ctgObject.sex" toggle-color="primary" dense
                        :options="[{ label: $t('default.male'), value: 'm' },
                                   { label: $t('default.female'), value: 'f' },
                                   { label: $t('default.sexBoth'), value: 'b' },]" />
        </q-field>
        <q-field class="q-mr-lg" borderless stack-label style="width: 3.7em;"
                 :label="$t('settings.categories.extra')">
          <q-checkbox v-model="ctgObject.extra" />
        </q-field>

        <q-btn glossy dense color="secondary" icon="far fa-check-circle"
               @click="saveCategory()" style="width: 50px"/>
      </div>

      <q-item>
        <q-item-label>

          <q-table
            :rows = "categoryData"
            :columns = "ctgColumns"
            :loading = "ctgLoading"
            :pagination = "ctgPagination"
            :rows-per-page-options="[0]"
            row-key = "startingNumber"
            dense
            color = "primary"
            hide-bottom
            @request = "ctgLoadDataFromDb"
          >
            <template v-slot:header-cell-delBtn="props">
              <q-td :props="props">
                <q-btn dense color="secondary" icon="fas fa-sort-amount-down-alt" @click="openReorderDialog()" />
              </q-td>
            </template>
            <template v-slot:body-cell-extra="props">
              <q-td :props="props">
                <span v-if="props.row.extra" class="fas fa-check"></span>
              </q-td>
            </template>
            <template v-slot:body-cell-editBtn="props">
              <q-td :props="props" style="width:40px">
                <q-btn dense color="secondary" icon="far fa-edit" @click="editCtg(props)"/>
              </q-td>
            </template>
            <template v-slot:body-cell-delBtn="props">
              <q-td :props="props" style="width:40px">
                <q-btn dense color="secondary" icon="far fa-trash-alt" @click="deleteCtg(props)" />
              </q-td>
            </template>
          </q-table>
        </q-item-label>
      </q-item>

      <q-separator />
      <q-item-label header>{{ $t('settings.disciples.h1') }}</q-item-label>

      <div class="row q-ma-md gutter-x-xs">
        <div>
          <q-input v-model="discObject.label" :label="$t('settings.disciples.name')" class="q-mr-md"
                   @keyup="keyupDisc" />
        </div>
        <q-field class="q-mr-md" stack-label
          :label="$t('settings.disciples.datatype')" :label-width="12">
          <q-btn-toggle v-model="discObject.datatype" toggle-color="primary" dense
                        :options="[{ label: $t('settings.disciples.typeNumber'), value: 'number' },
                                   { label: $t('settings.disciples.typeTime'), value: 'time' },
                                   { label: $t('settings.disciples.typeFp'), value: 'fp' },]" />
        </q-field>
        <q-field class="q-mr-md" stack-label
                 :label="$t('settings.disciples.direction')" :label-width="12">
          <q-btn-toggle v-model="discObject.direction" toggle-color="primary" dense
                        :options="[{ label: $t('settings.disciples.bestTop'), value: 'd' },
                                   { label: $t('settings.disciples.bestBottom'), value: 'a' },]" />
        </q-field>
        <q-btn glossy dense color="secondary" icon="far fa-check-circle"
               @click="saveDisc()" style="width: 50px"/>
      </div>

      <q-item>
        <q-item-label>
          <q-table
            :rows = "discData"
            :columns = "discColumns"
            :loading = "discLoading"
            :pagination = "discPagination"
            :rows-per-page-options="[0]"
            dense
            color = "primary"
            hide-bottom
            @request = "discLoadDataFromDb"
            >
              <template v-slot:body-cell-editBtn="props">
                <q-td :props="props" style="width:40px">
                  <q-btn dense color="secondary" icon="far fa-edit" @click="editDisc(props)" />
                </q-td>
              </template>
              <template v-slot:body-cell-delBtn="props">
                <q-td :props="props" style="width:40px">
                  <q-btn dense color="secondary" icon="far fa-trash-alt" @click="deleteDisc(props)" />
                </q-td>
              </template>
          </q-table>
        </q-item-label>
      </q-item>

      <q-separator />
      <q-item-label header>{{ $t('settings.discat.h1') }}</q-item-label>

      <q-item>
        <q-item-label>
          <q-table
            :rows = "discatData"
            :columns = "discatColumns"
            :loading = "discatLoading"
            :pagination = "discatPagination"
            :rows-per-page-options="[0]"
            row-key="name"
            dense
            color = "primary"
            hide-bottom
            @request = "discatLoadDataFromDb"
          >
            <template v-slot:top-right>
              <q-btn color="secondary" icon="far fa-save" @click="saveDiscats" />
            </template>

            <template v-slot:body="props">
              <tr :props="props">
                <q-td key="categoryId" :props="props">{{ props.row.categoryId }}</q-td>
                <template v-for="col in props.cols">
                  <q-td v-if="col.name === 'categoryName'" :key="col.name">
                    {{ props.row[col.name] }}
                  </q-td>
                  <q-td v-if="col.name !== 'categoryName'"
                        :key="col.name" :props="props">
                    <q-checkbox v-model="props.row[col.name]"/></q-td>
                </template>
              </tr>
            </template>
          </q-table>
        </q-item-label>
      </q-item>

      <q-separator />
      <q-item-label header>{{ $t('settings.output.h1') }}</q-item-label>

      <q-item class="row">
        <q-item-label class="col-grow q-mr-md">
            <q-field>
              <q-input v-model="settingObj.exportPath" style="width: 100%"
                       v-on:blur="saveExportPath"
                       :label="$t('settings.output.exportPath')" disabled />
              <input type="file" id="exportPath" v-on:change="setExportPath"
                     ref="fileInput" hidden webkitdirectory directory />
            </q-field>
        </q-item-label>
        <q-item-section right class="col-shrink">
            <q-btn color="primary" icon="fas fa-folder-open" style="width: 50px"
                   @click="selectPath" />
        </q-item-section>
      </q-item>

    </q-list>
  </q-page>
</template>

<script setup>
import log from 'src/service/messaging-service';
import Category from 'src/model/category';
import Disciple from 'src/model/disciple';
import {onMounted, reactive, ref, toRaw} from 'vue';
import {useQuasar} from 'quasar';
import CategorySorterDialog from '../components/CategorySorter.vue';

const ipcMain = window.ipcMain;
const $q = useQuasar();
const $t = log.getI18n();
const ctgColumns = [{
  name: 'name',
  field: 'name',
  label: 'Název',
}, {
  name: 'ageTo',
  field: 'ageTo',
  label: 'Rok nar. do (včetně)',
}, {
  name: 'sex',
  field: 'sexLabel',
  label: 'Pohlaví',
}, {
  name: 'extra',
  field: 'extra',
  label: 'Speciální',
}, {
  name: 'editBtn',
}, {
  name: 'delBtn',
}];
const discColumns =  [{
  name: 'label',
  field: 'label',
  label: 'Název',
}, {
  name: 'datatype',
  field: 'datatypeLabel',
  label: 'Měřená veličina',
}, {
  name: 'direction',
  field: 'directionLabel',
  label: 'Nejlepší',
}, {
  name: 'editBtn',
}, {
  name: 'delBtn',
}];
const ctgPagination = reactive({ page: 1, rowsPerPage: 50 });
const discatPagination = reactive({ page: 1, rowsPerPage: 50 });
const discPagination = reactive({ page: 1, rowsPerPage: 50 });

const categoryData = reactive([]);
const ctgLoading = ref(false);
const ctgObject = reactive(new Category());

const discLoading = ref(false);
const discData = reactive([]);

const discatLoading = ref(false);
const discatData = ref([]);
const discatColumns = reactive([]);

const discObject = reactive(new Disciple());
const settingObj = reactive({});

// ******* Category
async function ctgLoadDataFromDb() {
  ctgLoading.value = true;

  const data = await ipcMain.send('category-get-all-data');
  if (data.status === 'fail') log.error(data.message);
  else {
    data.message.forEach((row) => {
      if (row.sex === 'm') {
        row.sexLabel = $t('default.male');
      } else if (row.sex === 'f') {
        row.sexLabel = $t('default.female');
      } else {
        row.sexLabel = $t('default.sexBoth');
      }
    });
    categoryData.splice(0, categoryData.length, ...data.message);
    // ctgPagination.rowsNumber = data.total_rows;
    // ctgPagination.page = data.offset + 1;
    ctgLoading.value = false;
  }

  const resp = await ipcMain.send('setting-get-all-data');
  if (resp.status === 'fail') {
    log.error(resp.message);
  } else {
    Object.assign(settingObj, resp.message);
  }

}

function keyupCtg(evt) {
  if (evt.key === 'Enter') {
    saveCategory();
  }
}

async function saveCategory() {
  if (ctgObject.name && (ctgObject.extra || ctgObject.ageTo)) {
    const resp = ipcMain.send('category-save', {...ctgObject});
    if (resp.status === 'fail') log.error(resp.message);
    else {
      await ctgLoadDataFromDb();
      await discatLoadDataFromDb();
      Object.assign(ctgObject,  new Category());
      log.info($t('settings.categories.saveSuccess'));
    }
  } else {
    log.warn($t('settings.categories.mandatoryCheck'));
  }
}

function editCtg(category) {
  ctgObject._id = category.row._id;
  ctgObject.name = category.row.name;
  ctgObject.ageTo = category.row.ageTo;
  ctgObject.sex = category.row.sex;
  ctgObject.rank = category.row.rank;
  ctgObject.extra = category.row.extra;
}

function deleteCtg(category) {
  $q.dialog({
    title: $t('default.areYouSure'),
    message: $t('settings.categories.deletePrompt', { category: category.row.name }),
    ok: true,
    cancel: true,
  })
    .onOk(async () => {
      const resp = await ipcMain.send('category-delete', category.row._id);
      if (resp.status === 'fail') log.error(resp.message);
      else {
        await ctgLoadDataFromDb();
        await discatLoadDataFromDb();
        log.info($t('settings.categories.deleteSuccess'));
      }

    });
}

// ******* Disciple
async function discLoadDataFromDb() {
  discLoading.value = true;

  const data = await ipcMain.send('disciple-get-all-data');
  if (data.status === 'fail') log.error(data.message);
  else {
    data.message.docs.forEach((row) => {
      if (row.direction === 'a') {
        row.directionLabel = $t('settings.disciples.bestBottom');
      } else {
        row.directionLabel = $t('settings.disciples.bestTop');
      }
      if (row.datatype === 'fp') {
        row.datatypeLabel = $t('settings.disciples.typeFp');
      } else if (row.datatype === 'time') {
        row.datatypeLabel = $t('settings.disciples.typeTime');
      } else {
        row.datatypeLabel = $t('settings.disciples.typeNumber');
      }
    });
    discData.splice(0, discData.length, ...data.message.docs);
    // discPagination.rowsNumber = data.message.totalDocs;
    // discPagination.page = data.message.offset + 1;
    discLoading.value = false;

    discatColumns.splice(0, discatColumns.length, { name: 'categoryName', field: 'categoryName', label: 'Kategorie' });
    discatColumns.push(
      ...data.message.docs.map(
        (disc) => ({ name: `disc_${disc._id}`, field: `disc_${disc._id}`, label: disc.label }),
      ),
    );
  }

}

function keyupDisc(evt) {
  if (evt.key === 'Enter') {
    saveDisc();
  }
}

async function saveDisc() {
  if (discObject.label) {
    const resp = await ipcMain.send('disciple-save', { ...discObject });
    if (resp.status === 'fail') log.error(resp.message);
    else {
      await discLoadDataFromDb();
      await discatLoadDataFromDb();
      Object.assign(discObject, new Disciple());
      log.info($t('settings.disciples.saveSuccess'));
    }

  } else {
    log.warn($t('settings.disciples.mandatoryCheck'));
  }
}

function editDisc(disciple) {
  discObject._id = disciple.row._id;
  discObject.label = disciple.row.label;
  discObject.datatype = disciple.row.datatype;
  discObject.direction = disciple.row.direction;
}

function deleteDisc(disciple) {
  $q.dialog({
    title: $t('default.areYouSure'),
    message: $t('settings.disciples.deletePrompt', { disciple: disciple.row.label, category: disciple.row.categoryId }),
    ok: true,
    cancel: true,
  })
    .onOk(async() => {
      const result = await ipcMain.send('disciple-delete', disciple.row._id);
      if (result.statu === 'fail') log.error(result.message);
      else {
        await discLoadDataFromDb();
        await discatLoadDataFromDb();
        log.info($t('settings.disciples.deleteSuccess'));
      }

    });
}

// ******* Discat
async function discatLoadDataFromDb() {
  discatLoading.value = true;

  const data = await ipcMain.send('discat-get-all-data');
  if (data.status === 'fail') log.error(data.message);
  else {
    discatData.value.splice(0, discData.length, ...data.message);
    discatLoading.value = false;
  }
}

async function saveDiscats() {
  const result = await ipcMain.send('discat-save', toRaw(discatData.value));
  if (result.status === 'fail') log.error(result.message);
  else {
    await discatLoadDataFromDb();
    log.info($t('settings.discat.saveSuccess'));
  }

}

function selectPath() {
  $refs.fileInput.click();
}

function setExportPath(event) {
  // guess export path
  let pathSegments = [];
  Array.from(event.target.files).forEach((file) => {
    const segments = file.path.replace('\\', '/').split('/');
    if (pathSegments.length === 0 || pathSegments.length >= segments.length) {
      pathSegments = segments.slice(0, -1);
    }
  });

  if (pathSegments.length === 0) {
    log.warn($t('settings.emptyDirWarn'));
  } else {
    settingObj.exportPath = pathSegments.join('/');
    saveExportPath();
  }
}

function saveExportPath() {
  ipcMain.send('setting-changed', { ...settingObj });
}

function openReorderDialog() {
  $q.dialog({
    component: CategorySorterDialog,
    root: this.$root,
  }).onOk(() => {
    // počkej, až se propíše do DB a udělej refresh listu
    setTimeout(() => {
      ctgLoadDataFromDb();
      discatLoadDataFromDb();
    }, 1000);
  })
}

onMounted(() => {
  // once mounted, we need to trigger the initial server data fetch
  ctgLoadDataFromDb();
  discLoadDataFromDb();
  discatLoadDataFromDb();
})
</script>

<style>
</style>
